"use strict";
import Luci from "../luci.js";
import Api from "./api.js";

class ApiMqttIn {

    static luciReceived = [];
    static readStatusLuci = (outVal, payloadJSON) => {
        // TODO find connection IN-OUT
        const l = Luci.createLight('test' + Date.now(), payloadJSON.stato, 'in' + ApiMqttIn.luciReceived.length, outVal);
        ApiMqttIn.luciReceived.push(l);
        if (ApiMqttIn.luciReceived.length >= 8) {
            Api.sendLuciWeb(ApiMqttIn.luciReceived);
            ApiMqttIn.luciReceived = [];
        }
    }

    static outForToggleLuciStato = null;//out0/.../out7
    /**
     * 
     * @param {*} outVal out0/.../out7
     * @param {*} payloadJSON {event:0/1} luce accesa o spenta
     */
    static triggerLuce = (outVal, payloadJSON) => {
        console.log(outVal, payloadJSON, ApiMqttIn.outForToggleLuciStato);
        if (Api.outForToggleLuciStato == null) {
            // send to luci to figure out what is the connection
            Api.sendLuciStatoWeb({ luce: ApiMqttIn.outForToggleLuciStato, nome: outVal, evento: payloadJSON.evento });
        } else if (ApiMqttIn.outForToggleLuciStato.out === outVal && ApiMqttIn.outForToggleLuciStato.stato === payloadJSON.evento) {
            Api.sendLuciStatoWeb();
            ApiMqttIn.outForToggleLuciStato = null;
        }

        /*if(Api.outForToggleLuciStato == null){
            return;
        }
        if(ApiMqttIn.outForToggleLuciStato.out === outVal && ApiMqttIn.outForToggleLuciStato.stato === payloadJSON.stato){
            Api.sendLuciStatoWeb();
            ApiMqttIn.outForToggleLuciStato = null;
        }*/
    }

    static cambioStatoScenario = payloadJSON => {
        Api.sendWebNewScenarioStatus(payloadJSON);
    }

    static readStatoAutomaScenario = stato => {
        Api.sendWebScenarioAutoma(stato);
    }

    static renamedSavedScenario = payloadJSON => {
        Api.sendWebSavedScenario(JSON.parse(payloadJSON));
    }

    static readStatoAutomaAntifurto = stato => {
        Api.sendWebAntifurtoAutoma(stato);
    }

    static readAllRPCScenari = payloadJSON => {
        if (payloadJSON.status != null)//escludo le luci
            return;
        Api.sendScenariWeb(payloadJSON);
    }

}

export default ApiMqttIn;